package nxm.sys.inc;

/** A class that wraps the native null structure for null.
    @author Jay Hallam
    @version $Id: XGeoPlotIF.java,v 1.3 2014/10/21 18:43:28 ntn Exp $
 * */
public interface XGeoPlotIF {
  /** unknown */
  int XM_SEM_LOCAL = 0;

  /** unknown */
  int XM_SEM_GLOBAL = 1;

  /** unknown */
  int MAX_NUM_SEMS = 32;

  /** unknown */
  int XM_SHM_LOCAL = 0;

  /** unknown */
  int XM_SHM_GLOBAL = 1;

  /** unknown */
  int MAP_EXCLUSIVE = 0;

  /** unknown */
  int MAP_EXISTING = 1;

  /** unknown */
  int MAP_CREATE = 2;

  /** unknown */
  int MAX_NUM_SHM = 32;

  /** unknown */
  float XM_VERSION = 3.80f;

  /** unknown */
  String XM_SYS_VERSION_STRING = "3.8.0";

  /** unknown */
  int XM_SYS_VERSION = 3008000;

  /** unknown */
  int XM_SYS_VERSION_MAJOR = 3;

  /** unknown */
  int XM_SYS_VERSION_MINOR = 8;

  /** unknown */
  int XM_SYS_VERSION_SUB = 0;

  /** unknown */
  int L_M_PTR = 8;

  /** unknown */
  int L_M_PTR_P = 4;

  /** max size of ASCII result string */
  int L_MAX_ASCII = 80;

  /** max size of results name */
  int L_MAX_RESNAME = 40;

  /** unknown */
  float E = 2.718281828f;

  /** unknown */
  float PI = 3.141592654f;

  /** unknown */
  float HALFPI = 1.570796327f;

  /** unknown */
  float TWOPI = 6.283185308f;

  /** unknown */
  double DE = 2.718281828459045e0d;

  /** unknown */
  double DPI = 3.141592653589793238462643e0d;

  /** unknown */
  double DHALFPI = 1.570796326794896619231322e0d;

  /** unknown */
  double DTWOPI = 6.283185307179586476925287e0d;

  /** unknown */
  String STANDARD_WINDOWS = "NONE,BART,HANN,HAMM,BLACK,BH61,BH67,BH74,BH92,";

  /** unknown */
  float RAD2DEG = 57.295779513f;

  /** unknown */
  float DEG2RAD = 1.745329252e02f;

  /** unknown */
  double DRAD2DEG = 57.295779513082320876798155e0d;

  /** unknown */
  double DDEG2RAD = 1.7453292519943295769237e02d;

  /** Exact by international agreement */
  double FEET2METERS = 0.3048e0d;

  /** Exact by international agreement */
  double NM2METERS = 1852.0e0d;

  /** unknown */
  double NM2FEET = 6076.11548556e0d;

  /** Exact by international agreement */
  double SM2METERS = 1609.344e0d;

  /** Exact by international agreement */
  double SM2FEET = 5280.0e0d;

  /** unknown */
  double EARTH_ECCENTRICITY = 0.0818191908426e0d;

  /** in meters */
  double EARTH_EQUATORIAL_RADIUS = 6378137.0e0d;

  /** rad per mean solar sec */
  double EARTH_ANGULAR_VELOCITY = 7292115.8553e11d;

  /** unknown */
  double ANGULAR_VELOCITY_PRECESSING_COR = 4.3e15d;

  /** +- &#46;15E-11 */
  double DEF_EARTH_ANGULAR_VELOCITY = 7292115e11d;

  /** unknown */
  double IAU_EARTH_ANGULAR_VELOCITY = 7292115.1467e11d;

  /** 1/298&#46;257223563 */
  double EARTH_FLATTENING_FACTOR = 0.00335281066474e0d;

  /** unknown */
  double POLAR_RADIUS_IN_METERS = 6356752.3142e0d;

  /** unknown */
  double POLAR_RADIUS_OF_CURVATURE = 6399593.6258e0d;

  /** unknown */
  double MASS_OF_EARTH_W_ATMOS = 5.9733328e24d;

  /** +- &#46;6 */
  double EARTH_GRAV_CONSTANT_W_ATMOS = 3986005e08d;

  /** +- &#46;6 */
  double EARTH_GRAV_CONSTANT_WO_ATMOS = 3986001.5e08d;

  /** +- 1&#46;2 m/sec */
  double SPEED_OF_LIGHT = 299792458e0d;

  /** unknown */
  int L_QUADWORDS = 12;

  /** unknown */
  int L_COMPONENTS = 14;

  /** unknown */
  int L_SUBRECORDS = 26;

  /** unknown */
  int L_OUTLETS = 8;

  /** unknown */
  int L_KEYWORDS = 92;

  /** unknown */
  int L_HEADER_SIZE = 2048;

  /** length of T6 subr&#46; def&#46; string */
  int L_T6SUBR_STR_LEN = 96;

  /** size of T6 subr&#46; def&#46; table */
  int L_T6SUBR_LEN = 64;

  /** unknown */
  int L_MAX_PKT_SIZE = 2048;

  /** unknown */
  int L_PKT_STRUCT_SIZE = 376;

  /** unknown */
  int L_MAX_PKT_REG = 32;

  /** unknown */
  int L_PKT_HD_SIZE = 8;

  /** Do not bridge across meta-data for xfers */
  int PK_NOBRIDGE = 1;

  /** Do not propagate meta-data packets */
  int PK_NOPROP = 2;

  /** Flag to put M$GRABX in SEEK mode */
  int PK_SEEK = 4;

  /** Flag for libs to mod HCB */
  int PK_HDRMOD = 8;

  /** unknown */
  int T6O_NAME = 0;

  /** unknown */
  int T6O_MINVAL = 24;

  /** unknown */
  int T6O_MAXVAL = 32;

  /** unknown */
  int T6O_OFFSET = 40;

  /** unknown */
  int T6O_NUM_ELTS = 44;

  /** unknown */
  int T6O_UNITS = 48;

  /** unknown */
  int T6O_UPREFIX = 52;

  /** unknown */
  int T6O_FORMAT = 56;

  /** size of vrb header */
  int L_VRBHEAD = 24;

  /** size of key header */
  int L_KEYHEAD = 8;

  /** unknown */
  int MK_NORMAL = 0;

  /** unknown */
  int MK_MAIN = 1;

  /** unknown */
  int MK_EXT = 2;

  /** unknown */
  int MK_NOSCOPE = 4;

  /** unknown */
  int MK_NEXT = 8;

  /** unknown */
  int MK_TYPEASIS = 16;

  /** unknown */
  int MK_TYPETAG = 32;

  /** unknown */
  int MK_REPLACE = 64;

  /** unknown */
  int MK_INDEX = 128;

  /** unknown */
  int MK_NEXTMATCH = 256;

  /** unknown */
  int MK_LAST = 512;

  /** unknown */
  int BK_MAIN = 0;

  /** unknown */
  int BK_EXT = 1;

  /** unknown */
  int BK_NOSCOPE = 2;

  /** unknown */
  int BK_NEXT = 3;

  /** unknown */
  int BK_TYPEASIS = 4;

  /** unknown */
  int BK_TYPETAG = 5;

  /** unknown */
  int BK_REPLACE = 6;

  /** unknown */
  int BK_INDEX = 7;

  /** unknown */
  int BK_NEXTMATCH = 8;

  /** unknown */
  int BK_LAST = 9;

  /** unknown */
  int VRB_INIT = 1;

  /** unknown */
  int VRB_OFFSET = 2;

  /** unknown */
  int VRB_READ = 3;

  /** unknown */
  int VRB_WRITE = 4;

  /** unknown */
  int HCBF_CTG = 1;

  /** unknown */
  int HCBF_AUX = 2;

  /** unknown */
  int HCBF_SAM = 4;

  /** unknown */
  int HCBF_FLUSH = 8;

  /** unknown */
  int HCBF_APPEND = 16;

  /** unknown */
  int HCBF_REOPEN = 32;

  /** unknown */
  int HCBF_LASTBYTE = 64;

  /** unknown */
  int HCBF_DETACH = 128;

  /** unknown */
  int HCBF_INPUT = 256;

  /** unknown */
  int HCBF_OUTPUT = 512;

  /** unknown */
  int HCBF_HCBMOD = 1024;

  /** unknown */
  int HCBF_OPTIONAL = 2048;

  /** unknown */
  int HCBF_NOABORT = 4096;

  /** unknown */
  int HCBF_PRESERVE = 8192;

  /** unknown */
  int HCBF_WAIT = 16384;

  /** unknown */
  int HCBF_EOF = 32768;

  /** unknown */
  int HCBF_AVAIL = 65536;

  /** unknown */
  int HCBF_SKIP = 131072;

  /** unknown */
  int HCBF_PS = 262144;

  /** max # of 'ordinary' macro levels */
  int L_MLEVELS = 32;

  /** max spawned macro level */
  int L_MACROS = 96;

  /** max size of read auxilary list */
  int L_AUXS = 64;

  /** max total characters of all auxs */
  int L_AUXBYTES = 4096;

  /** max index into auxiliary table */
  int L_MAXAUXINDEX = 255;

  /** max chars in command line */
  int L_CMD_CHARS = 1024;

  /** max global switch chars */
  int L_GSW_CHARS = 1024;

  /** max files/prim for overwrite autochk */
  int L_FILES = 10;

  /** max results array files open at once */
  int L_SHELLFILES = 10;

  /** max user scratch fields */
  int L_USERSCR = 32;

  /** max length of pipe name */
  int L_PIPE_NAME = 32;

  /** max scalars per atom */
  int L_MAXSPA_ = 16;

  /** max number of global sections */
  int L_SECTIONS = 64;

  /** shared section mask - bits 3,4,5 */
  int L_SHRMASK = 56;

  /** unknown */
  int LS_MIDAS = 1;

  /** unknown */
  int LS_TABLES = 2;

  /** unknown */
  int LS_RESULTS = 3;

  /** unknown */
  int LS_MESSAGES = 4;

  /** unknown */
  int LS_DICTIONARY = 5;

  /** unknown */
  int LS_MACROSTACK = 6;

  /** unknown */
  int LS_PIPE_HEADERS = 7;

  /** unknown */
  int LS_PIPE_BUFFERS = 8;

  /** unknown */
  int LS_CNTRL_WIDGETS = 9;

  /** unknown */
  int LS_DS_STRUCTS = 10;

  /** unknown */
  int LS_USER_OFFSET = 10;

  /** unknown */
  int LS_USER1 = 11;

  /** unknown */
  int LS_USER2 = 12;

  /** unknown */
  int LS_USER3 = 13;

  /** unknown */
  int LS_PNAME = 14;

  /** unknown */
  int LS_REMOTE = 15;

  /** ipc message buffer */
  int LS_ERMIF_IPC = 16;

  /** pipe tranesfer buffers */
  int LS_REMOTE_PIPES_OFFSET = 17;

  /** unknown */
  int L_SEMAPHORES = 9;

  /** key for M$LOCK */
  int LS_ALL_SECTIONS = -1;

  /** max user sections */
  int L_USERSEC = L_SECTIONS-LS_USER_OFFSET;

  /** unknown */
  int LD_WAIT = 1;

  /** unknown */
  int LD_SUBSHELL = 2;

  /** unknown */
  int LD_SMART = 4;

  /** unknown */
  int LD_SYMBOLS = 8;

  /** unknown */
  int LD_NOINPUT = 16;

  /** unknown */
  int L_MIDAS_COMMON = 8220;

  /** unknown */
  int L_MAX_PKT_FILES = 36;

  /** unknown */
  int L_MU_PKT_ADJUNCT_SIZE = L_MAX_PKT_FILES*328+4;

  /** unknown */
  int L_MIDAS_UNIQUE = 472+L_MU_PKT_ADJUNCT_SIZE;

  /** Each record in 88 bytes */
  int PNAME_RECORD_SIZE = 88;

  /** Number of records in array */
  int PNAME_ARRAY_SIZE = 512;

  /** unknown */
  int L_PNAME = PNAME_RECORD_SIZE*PNAME_ARRAY_SIZE;

  /** unknown */
  int P_NULL = 0;

  /** unknown */
  int P_PIPE = 1;

  /** unknown */
  int P_RESULT = 2;

  /** unknown */
  int P_KEY = 3;

  /** unknown */
  int P_MESSAGE = 4;

  /** unknown */
  int P_MACRO = 5;

  /** unknown */
  int P_XCONTROL = 6;

  /** unknown */
  int P_XCALL = 7;

  /** unknown */
  int REMOTE_RECORD_SIZE = 768;

  /** Number of records in array */
  int REMOTE_ARRAY_SIZE = 256;

  /** unknown */
  int L_REMOTE = REMOTE_RECORD_SIZE*REMOTE_ARRAY_SIZE;

  /** unknown */
  int IPC_SLOTS_MAIN_MACRO = 1024;

  /** unknown */
  int IPC_SLOTS_PER_MACRO = 128;

  /** unknown */
  int IPC_MAX_MACROS = 16;

  /** unknown */
  int IPC_MAX_MACROS_SLOTS = IPC_MAX_MACROS*IPC_SLOTS_PER_MACRO;

  /** unknown */
  int ERMIF_TABLE_SIZE = IPC_SLOTS_MAIN_MACRO+IPC_MAX_MACROS_SLOTS;

  /** unknown */
  int ERMIF_STR_LEN = 224;

  /** unknown */
  int ERMIF_SIZE = 256;

  /** unknown */
  int L_ERMIF_IPC = ERMIF_TABLE_SIZE*4+ERMIF_TABLE_SIZE*ERMIF_SIZE;

  /** unknown */
  int L_ARROWLEFT = 1001;

  /** unknown */
  int L_ARROWRIGHT = 1002;

  /** unknown */
  int L_ARROWUP = 1003;

  /** unknown */
  int L_ARROWDOWN = 1004;

  /** unknown */
  int L_RETURNKEY = 1005;

  /** unknown */
  int L_INSERTKEY = 1006;

  /** unknown */
  int L_DELETEKEY = 1007;

  /** unknown */
  int L_F14KEY = 1008;

  /** unknown */
  int L_TABKEY = 1009;

  /** unknown */
  int L_HELPKEY = 1010;

  /** unknown */
  int L_SHIFTKEYMASK = 1;

  /** unknown */
  int L_CONTROLKEYMASK = 2;

  /** unknown */
  int L_MOD1KEYMASK = 4;

  /** unknown */
  int L_MOD2KEYMASK = 8;

  /** unknown */
  int L_MOD3KEYMASK = 16;

  /** unknown */
  int L_MOD4KEYMASK = 32;

  /** unknown */
  int L_MOD5KEYMASK = 64;

  /** unknown */
  int L_BUTTON1MASK = 128;

  /** unknown */
  int L_BUTTON2MASK = 256;

  /** unknown */
  int L_BUTTON3MASK = 512;

  /** unknown */
  int L_CLIENTEVENTMASK = 32768;

  /** unknown */
  int L_AVALREDRAW = -2;

  /** unknown */
  int L_BGCOLOR = 0;

  /** unknown */
  int L_FGCOLOR = -1;

  /** unknown */
  int L_XORCOLOR = -2;

  /** unknown */
  int L_XWFGCOLOR = -3;

  /** unknown */
  int L_XWBGCOLOR = -4;

  /** unknown */
  int L_XWTSCOLOR = -5;

  /** unknown */
  int L_XWBSCOLOR = -6;

  /** unknown */
  int L_XWLOCOLOR = -7;

  /** unknown */
  int L_NOCOLOR = -8;

  /** unknown */
  int L_CONVEX = 1;

  /** unknown */
  int L_NONCONVEX = -1;

  /** unknown */
  int L_SOLID = 800;

  /** unknown */
  int L_DASHED = 801;

  /** unknown */
  int L_RMODEOFF = 900;

  /** unknown */
  int L_RMODEON = 901;

  /** unknown */
  int L_PIXELSYMBOL = 1;

  /** unknown */
  int L_CIRCLESYMBOL = 2;

  /** unknown */
  int L_SQUARESYMBOL = 3;

  /** unknown */
  int L_PLUSSYMBOL = 4;

  /** unknown */
  int L_XSYMBOL = 5;

  /** unknown */
  int L_TRIANGLESYMBOL = 6;

  /** unknown */
  int L_ITRIANGLESYMBOL = 7;

  /** unknown */
  int L_SENDBUTTONPRESS = 1;

  /** unknown */
  int L_SENDBUTTONRELEASE = -1;

  /** unknown */
  int L_SENDKEYPRESS = 2;

  /** unknown */
  int L_SENDKEYRELEASE = -2;

  /** unknown */
  int L_SENDMOTION = 3;

  /** unknown */
  int L_USEREVENTS_MSG = 4;

  /** unknown */
  int L_DEICONIFY_MSG = 5;

  /** unknown */
  int L_ICONIFY_MSG = -5;

  /** unknown */
  int L_FOCUS_MSG = 6;

  /** unknown */
  int L_MOVERESIZE_MSG = 7;

  /** unknown */
  int L_MOVE_MSG = 8;

  /** unknown */
  int L_RESIZE_MSG = 78;

  /** unknown */
  int L_TEACH_MSG = 999;

  /** unknown */
  int L_LEARN_MSG = -999;

  /** unknown */
  int L_GRIDLINES = 1;

  /** unknown */
  int L_NOAXISBOX = 2;

  /** unknown */
  int L_NOXTICS = 4;

  /** unknown */
  int L_NOYTICS = 8;

  /** unknown */
  int L_NOXTLAB = 16;

  /** unknown */
  int L_NOYTLAB = 32;

  /** unknown */
  int L_NOXPLAB = 64;

  /** unknown */
  int L_NOYPLAB = 128;

  /** unknown */
  int L_XONTOP = 256;

  /** unknown */
  int L_YONRIGHT = 512;

  /** unknown */
  int L_EXACTBOX = 1024;

  /** unknown */
  int L_INSIDELAB = 2048;

  /** unknown */
  int L_NOXSPECS = L_NOXTICS+L_NOXTLAB+L_NOXPLAB;

  /** unknown */
  int L_NOYSPECS = L_NOYTICS+L_NOYTLAB+L_NOYPLAB;

  /** unknown */
  int L_CBENABLE = 1;

  /** unknown */
  int L_CBITEM = 2;

  /** unknown */
  int L_CBNOMASK = 0;

  /** unknown */
  int L_CBAUTOMASK = 1;

  /** unknown */
  int L_CBEXIT = -1;

  /** unknown */
  int L_CBNOACTION = 0;

  /** unknown */
  int L_CBOKACTION = 1;

  /** unknown */
  int L_STKSTRUCT = 64;

  /** unknown */
  int L_XSTACK = L_STKSTRUCT;

  /** unknown */
  int L_MAPSTRUCT = 12;

  /** unknown */
  int L_PIXSTRUCT = 4;

  /** unknown */
  int L_FREEMAP = 1;

  /** unknown */
  int L_NEWMAP = 2;

  /** unknown */
  int L_PUTMAP = 4;

  /** unknown */
  int L_MOVEMAP = 8;

  /** unknown */
  int L_CLIPMAP = 16;

  /** unknown */
  int L_STACK = 10;

  /** unknown */
  int L_COLOR = 64;

  /** unknown */
  int L_ZOOMMAX = 10;

  /** DR 11175 */
  int L_MX = 1624;

  /** unknown */
  int L_CLEANEXIT = 0;

  /** unknown */
  int L_DRAW = 1;

  /** unknown */
  int L_INTERACTIVE = (-1);

  /** unknown */
  int L_ONESHOT = (-2);

  /** unknown */
  int L_PRELOAD = (-3);

  /** unknown */
  int L_INITFACILITIES = 999;

  /** unknown */
  int L_REMOVETEXT = (-1);

  /** unknown */
  int L_DESELECTTEXT = 0;

  /** unknown */
  int L_SELECTTEXT = 1;

  /** unknown */
  int L_MOVETEXT = 2;

  /** unknown */
  int L_FREEFONTS = (-2);

  /** unknown */
  int L_LOADONEFONT = (-1);

  /** unknown */
  int L_FONTATTRIBUTES = 0;

  /** unknown */
  int L_CHANGEBG = 1;

  /** unknown */
  int L_LOADALLFONTS = 2;

  /** unknown */
  int L_CHANGECOLOR = 3;

  /** unknown */
  int L_CHANGEANCHOR = 4;

  /** unknown */
  int L_GETFONTPTR = 5;

  /** unknown */
  int L_FREEFONTPTR = (-5);

  /** unknown */
  int L_GETTEXTEXTENTS = (-4);

  /** unknown */
  int L_SETPIXEL = (-3);

  /** unknown */
  int L_NOTSET = (-1);

  /** unknown */
  int L_XFAFILL = 1;

  /** unknown */
  int L_XFAMIDANCHOR = 2;

  /** unknown */
  int L_XFAENDANCHOR = 4;

  /** unknown */
  int L_XFANOGRAVITY = 8;

  /** unknown */
  int L_XFANOBS = 16;

  /** unknown */
  int L_XFANNOTATION = 312;

  /** unknown */
  int L_XFBOX = 32;

  /** unknown */
  int L_SAVEPANEL = 4;

  /** unknown */
  int L_FOCUSPANEL = 5;

  /** unknown */
  int XFC_DISP = 1;

  /** unknown */
  int XFC_AWAKE = 2;

  /** unknown */
  int XFC_EDIT = 4;

  /** unknown */
  int XFC_MONITOR = 8;

  /** unknown */
  int XFC_MFOCUS = 16;

  /** unknown */
  int XFC_BLINK = 32;

  /** unknown */
  int XFC_MOPTION = 64;

  /** unknown */
  int XFC_MLEFT = 128;

  /** unknown */
  int XFC_MTOP = 256;

  /** unknown */
  int XFC_MRIGHT = 512;

  /** unknown */
  int L_XFPOINT = 16;

  /** jdh updated for MRM additions */
  int L_XFACILITIES = 10*L_M_PTR+120;

  /** unknown */
  int MSK_ZOOM = 8;

  /** unknown */
  int MSK_PANX = 9;

  /** unknown */
  int MSK_PANY = 10;

  /** unknown */
  int MSK_CXMODE = 11;

  /** unknown */
  int MSK_EXIT = 12;

  /** unknown */
  int MSK_UNZOOM = 13;

  /** unknown */
  int MSK_BOXES = 14;

  /** unknown */
  int MSK_POINTS = 15;

  /** unknown */
  int MSK_MARK = 16;

  /** unknown */
  int MSK_ECHO = 17;

  /** unknown */
  int MSK_COLOR = 18;

  /** unknown */
  int MSK_MODIFY = 19;

  /** unknown */
  int MSK_LOOKUP = 20;

  /** unknown */
  int MSK_SELECT = 21;

  /** unknown */
  int MSK_HLIT = 22;

  /** unknown */
  int MSK_NEWFILE = 23;

  /** unknown */
  int L_EVENTSZ = 32+1*8+2*4+3*2*8+3*8+15*8;

  /** unknown */
  int L_LAYERSZ = 1*32+4*4+6*4+6*4+4*4+2*8;

  /** unknown */
  int L_EVENTMX = 32,L_LAYERMX=32;

  /** unknown */
  int L_T5RECSZ = 3*8+3*8+3*8+8+8;

  /** unknown */
  int L_NBALL = 8,L_MG=21,L_GRID=4232,L_CTMP=65536,L_PIX=8192;

  /** unknown */
  int L_COLORS = 32,PC_MAPOFF=5,PC_USEROFF=16;

  /** unknown */
  int PC_GRID = 1,PC_HORIZON=2,PC_TDOA=3,PC_FDOA=4,PC_TRACE=5;

  /** unknown */
  int PC_CEP = -1,PC_MAP=-2,PC_USER=-3,PC_RAW=-4;

  /** unknown */
  int PG_TDOA = 1,PG_FDOA=2,PG_TFDOA=3;

  /** unknown */
  int PG_CURRENT = 1,PG_CURROFF=2,PG_FIXED=3;

  /** unknown */
  int PG_LINE = 1,PG_CONTOUR=2,PG_REGION=3,PG_NONE=4;

  /** unknown */
  int P_ON = 1,P_OFF=2;

  /** unknown */
  int P_NOCONE = 0,P_GEOCONE=-1,P_DEFCONE=-9,P_TEXT=-99;

  /** unknown */
  int P_INIT = -1,P_NORM=0,P_ZOOM=1,P_FAST=2,P_GRID=3,P_MENU=-9;

  /** unknown */
  int P_BASE = 1,P_WIDE=2,P_NARROW=-2,P_RESIZE=3;

  /** unknown */
  int P_ENABLE = 255,P_DISABLE=P_ENABLE-2;

  /** unknown */
  int PM_GLOBAL = 1,PM_LABEL=2,PM_BS=3;

  /** unknown */
  int PM_BASE = 4,PM_ZOOM=5,PM_FBASE=6,PM_FZOOM=7;

  /** unknown */
  int PP_CLEAR = -1,PP_OFF=0,PP_FIFO=1,PP_WRAP=2,PP_CONSUME=3;

  /** unknown */
  int PM_LTC = 1,PM_DWNLNK=2,PM_HORIZON=3,PM_POINTS=4;

  /** unknown */
  int PM_AUTOTF = 5;

  /** unknown */
  int P_CFG = -1,P_EVN=-2;

  /** unknown */
  int P_SITE = 1,P_SV=2,P_LAYER=3,P_EVENT=4,P_ALTDB=5;

  /** unknown */
  int P_METRIC = 1,P_ENGLISH=2,P_NAUTICAL=3;

  /** unknown */
  int P_METERS = 5,P_DEGREES=34;

  // <BBMakeGenCode>//GEN-BEGIN:BBMakeGenCode
  /* This next section of code generated by BBDEF2JAVA in CONVERT.
     DO NOT EDIT THIS CODE, it will be re-written every time
     BBDEF2JAVA is run and any changes will be lost.
   */
  //   <editor-fold defaultstate="collapsed" desc=" Generated Code ">
  //   </editor-fold>
  // </BBMakeGenCode>//GEN-END:BBMakeGenCode
}

