package nxm.sys.libg;

import nxm.sys.inc.LimitedFutureSupport;
import nxm.sys.inc.MessageHandler;

/** ***** STANDARD VERSION - BACKWARDS COMPATIBLE ***

 *  @author Jeanette McCall
 *  @since NeXtMidas 4.0.0
 */
class GWidgetModSwap extends MWindow {

  public GWidgetModSwap () {};

  public GWidgetModSwap (String name, MessageHandler mh, Object parent) {
    super (name,mh,parent);
  }

  /** the widget panel this is displayed on */
  @LimitedFutureSupport("Type is going to change from nxm.sys.inc.WidgetPanel to nxm.sys.libg.WidgetPanel")
  public nxm.sys.inc.WidgetPanel wp;

  /** Sets the optional widget panel for this widget.
     @param wp the WidgetPanel for this widget.
  */
  public void setWidgetPanel (nxm.sys.inc.WidgetPanel wp) {
   this.wp = wp;
  }

  /** @return the widget panel */
  @LimitedFutureSupport("Use getGWidgetPanel() - since 3.9.2 for JDK modularity")
  public nxm.sys.inc.WidgetPanel getWidgetPanel() {
    return this.wp;
  }
}
