package nxm.sys.libg;

import javax.swing.UIDefaults;
import javax.swing.plaf.metal.MetalTheme;

/** A class to hold a Color theme for Windows and Widgets. <br>
    <br>
    Since NeXtMidas 1.9.3 this class extends {@link MetalTheme} rather than {@link Object}. This
    change was made so that this "NeXtMidas Theme" can also be used as a theme for the "Metal" Look
    and Feel (the default look and feel for Java). Note that the Java look and feels (and the Metal
    themes) are intended to be used as global settings whereas the NeXtMidas themes can be used
    in a localized manner (since NeXtMidas 3.3.0).

    NOTE: Users should generally KEEP referring to LIBG Theme. Only users that plan
    to only use the non-graphical JDK module (when than transition takes place should change
    their Theme references to be the lib.Theme

    @author Jeff Schoen
*/
public class Theme extends nxm.sys.lib.Theme {

  /** Creates one of the legacy themes. This constructor is private and should only be called from
      other constructors or when creating the set of legacy themes.
      @param a   The name of the current theme.
      @param b  A description of the theme.
   */
  public Theme (String a, String b) {
    super(a,b);
  }

  /** Creates a default theme */
  public Theme() {
    super();
  }

  /** Creates a new theme based on a Swing Look and Feel.
      @param name The name of the Look and Feel.
      @param prop The properties of that look and feel.
   */
  public Theme (String name, UIDefaults prop) {
    super(name,prop);
  }
}
