#ifndef XM_XMVERSION_H_
/*
 ************

   $Id: xmversion.h,v 1.2 2009/08/21 15:56:46 ntn Exp $

   Description: Defines Midas SYS area version constants.

 ************
*/

/*
  X-Midas latest major revision parameter
*/

#define XM_Version 4.45
#define XM_SYS_VERSION_STRING "4.4.5"
#define XM_SYS_VERSION 4004005
#define XM_SYS_VERSION_MAJOR 4
#define XM_SYS_VERSION_MINOR 4
#define XM_SYS_VERSION_SUB   5
/* The MIDAS_VERSION_CODE macro converts a triple-number version number to
 * a single integer that can be used in preprocessor directives.
 * For example:

 #if XM_SYS_VERSION < MIDAS_VERSION_CODE(3,6,5)
   add workaround
 #endif
*/

#ifndef MIDAS_VERSION_CODE
#define MIDAS_VERSION_CODE(_maj,_min,_plvl) \
   ((_plvl) + 1000*((_min) + 1000*(_maj)))
#endif /* MIDAS_VERSION_CODE */

#define XM_SYS_VERSION_AT_LEAST(_maj,_min,_plvl) \
   (XM_SYS_VERSION >= MIDAS_VERSION_CODE(_maj,_min,_plvl))
#define XM_XMVERSION_H_
#endif /* XM_XMVERSION_H_ */

