package nxm.sys.inc;

/**
  Defines command verification options.

  @author Jeff Schoen
  @version $Id: Verify.java,v 1.6 2014/10/21 18:43:28 ntn Exp $
*/
public interface Verify {
  /** Command verification option indicating that the commands should be echoed to the terminal.
      @see #verifyList
   */
  int COMMANDS=0x01;

  /** Command verification option indicating that the switches should be echoed to the terminal.
      @see #verifyList
   */
  int SWITCHES=0x02;

  /** Command verification option indicating that the qualifiers should be echoed to the terminal.
      @see #verifyList
   */
  int QUALIFIERS=0x04;

  /** Command verification option indicating that any commands run while a macro
      is processing a message should be echoed to the terminal.
      @see #verifyList
   */
  int CONTROLS=0x08;

  /** Command verification option indicating that a beep should be sounded when a command completes.
      @see #verifyList
   */
  int BEEP=0x10;

  /** Command verification option indicating that the breaks should be echoed to the terminal.
      @see #verifyList
   */
  int BREAK=0x20;

  /** Comma-separated list of command verification options.
      @see #COMMANDS
      @see #SWITCHES
      @see #QUALIFIERS
      @see #CONTROLS
      @see #BEEP
      @see #BREAK
   */
  String verifyList = "Commands,Switches,Qualifiers,Controls,Beep,Break";
}
